/*******************************************************************************
 **
 ** $Id: plotwindow.C 157 2008-11-29 22:11:56Z AndrewLahiff $
 **
 ******************************************************************************
 **
 ** Copyright (C) 2007-2008 Andrew Lahiff.
 **
 ** This file is part of plotcf.
 **
 ** plotcf is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** plotcf is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with plotcf.  If not, see <http://www.gnu.org/licenses/>.
 **
 *******************************************************************************/

#include "plotwindow.h"

//-----------------------------------------------------------------------------
//
// constructor
//
//-----------------------------------------------------------------------------

PlotWindow::PlotWindow(int userPlotWidth, int userPlotHeight, QWidget *parent) : QWidget(parent)
{
   setFixedSize(userPlotWidth, userPlotHeight);
   setPalette(QPalette(QColor(255, 255, 255)));
   setAutoFillBackground(true);
   setWindowTitle("plotcf");

   plot = new QImage;
}

//-----------------------------------------------------------------------------
//
// set window size
//
//-----------------------------------------------------------------------------

void PlotWindow::setWindowSize(int userPlotWidth, int userPlotHeight)
{
   plotWidth = userPlotWidth;
   plotHeight = userPlotHeight;

// if the size of the plot has changed, change the size of the window

   if (plotWidth != userPlotWidth || plotHeight != userPlotHeight)
   {
      setFixedSize(plotWidth, plotHeight);
   }
}

//-----------------------------------------------------------------------------
//
// paint the image
//
//-----------------------------------------------------------------------------

void PlotWindow::paintEvent(QPaintEvent *)
{  
   QPainter painter(this);
   painter.drawImage(QPointF(0., 0.), *plot);
}

