/******************************************************************************
 **
 ** $Id: wheel.h 183 2009-04-24 12:33:15Z AndrewLahiff $
 **
 ******************************************************************************
 **
 ** Copyright (C) 2007-2009 Andrew Lahiff.
 **
 ** This file is part of plotcf.
 **
 ** plotcf is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** plotcf is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with plotcf.  If not, see <http://www.gnu.org/licenses/>.
 **
 *******************************************************************************/

#ifndef WHEEL_H_
#define WHEEL_H_

class QString;

struct WheelData
{
    int file;
    int var;
    bool az_req;
    QString name;
    bool enabled;
    bool reflection;
    bool bl;
};

class ReadFile; 
class QWheelPlot;

int getVarAzi(ReadFile& file, int var);

class Wheel
{
    int num_en; // number of energy bins
    int num_pa; // number of polar bins
    int num_az; // number of azimuth bins

    std::vector<float> pa_cen;
    std::vector<float> pa_low;
    std::vector<float> pa_upp;

    std::vector<float> az_cen;
    std::vector<float> az_low;
    std::vector<float> az_upp;

    std::vector<float> en_cen;
    std::vector<float> en_low;
    std::vector<float> en_upp;

    std::vector<float> data;

    double fillEnergy;
    double fillPolar;
    double fillAzimuth;
    double fillData;

    bool reflection_;

public:
    Wheel();
    ~Wheel() {};
    bool getData(int varNum, bool getAz, ReadFile& file);
    void plot(QWheelPlot& plot, bool side, double ymin, double ymax, bool seten);
    void includeReflection(bool refl = true);
};

#endif // WHEEL_H_

