/*******************************************************************************
 **
 **  $Id: metadata.h 154 2008-11-29 05:36:59Z AndrewLahiff $
 **
 ******************************************************************************
 **
 ** Copyright (C) 2007-2008 Andrew Lahiff.
 **
 ** This file is part of ReadFile.
 **
 ** ReadFile is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** ReadFile is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with ReadFile.  If not, see <http://www.gnu.org/licenses/>.
 **
 *******************************************************************************/

#ifndef METADATA_H_
#define METADATA_H_

#include <QString>

//-----------------------------------------------------------------------------
//
// GlobalMetaData class
//
//-----------------------------------------------------------------------------

class GlobalMetaData
{
public:
   QString MISSION;
   QString OBSERVATORY;
   QString EXPERIMENT;
   QString INSTRUMENT_NAME;
   QString DATASET_ID;
   QString DATASET_TITLE;
   QString LOGICAL_SOURCE;
   QString DATA_TYPE;

   void initialize();
};

//-----------------------------------------------------------------------------
//
// VariableMetaData class
//
//-----------------------------------------------------------------------------

class VariableMetaData
{
public:
   QString NAME; 
   QString PARAMETER_TYPE;
   QString SI_CONVERSION;
   QString PROPERTY;
   QString UNITS;
   QString SCALEMIN;
   QString SCALEMAX;
   QString SCALETYP;
   QString FILLVAL;
   QString SIZES;
   QString LABLAXIS;
   QString VALUE_TYPE;
   QString DISPLAYTYPE;
   QString LABEL_1;
   QString LABEL_2;
   QString LABEL_3;
   QString DEPEND_0;
   QString DEPEND_1;
   QString DEPEND_2;
   QString DEPEND_3;
   QString REPRESENTATION_1;
   QString REPRESENTATION_2;
   QString REPRESENTATION_3;
   QString DELTA_PLUS;
   QString DELTA_MINUS;
   QString FIELDNAM;
   QString VAR_TYPE;
   QString ENTITY;
   QString TENSOR_FRAME;
   QString TENSOR_RANK;
   QString CATDESC;
   QString DISPLAY_TYPE;

   void initialize();
};

#endif //METADATA_H_
